diff -u --recursive libdvdcss-1.2.1/src/css.c libdvdcss-1.2.1-fixed/src/css.c
--- libdvdcss-1.2.1/src/css.c	Sun Jun  2 17:05:34 2002
+++ libdvdcss-1.2.1-fixed/src/css.c	Wed Jun 26 20:48:32 2002
@@ -190,7 +190,7 @@
         if( memcmp( p_key_check, p_key1, KEY_SIZE ) == 0 )
         {
             snprintf( psz_warning, sizeof(psz_warning),
-                      "drive authentic, using varient %d", i );
+                      "drive authentic, using variant %d", i );
             _dvdcss_debug( dvdcss, psz_warning );
             i_varient = i;
             break;
diff -u --recursive libdvdcss-1.2.1/src/libdvdcss.c libdvdcss-1.2.1-fixed/src/libdvdcss.c
--- libdvdcss-1.2.1/src/libdvdcss.c	Sun Jun  2 16:54:10 2002
+++ libdvdcss-1.2.1-fixed/src/libdvdcss.c	Wed Jun 26 20:51:38 2002
@@ -300,6 +300,7 @@
 {
     dvd_title_t *p_title;
     dvd_title_t *p_newtitle;
+    dvd_title_t *p_firsttitle;
     dvd_key_t    p_title_key;
     int          i_ret;
 
@@ -335,13 +336,14 @@
     }
     else if( i_ret == 0 )
     {
-        _dvdcss_debug( dvdcss, "unecrypted title" );
+        _dvdcss_debug( dvdcss, "unencrypted title" );
         /* Still store this in the cache, so we don't need to check again. */
     }
 
     /* Find our spot in the list */
     p_newtitle = NULL;
     p_title = dvdcss->p_titles;
+    p_firsttitle = p_title;
     while( ( p_title != NULL ) && ( p_title->i_startlb < i_block ) )
     {
         p_newtitle = p_title;
@@ -357,10 +359,16 @@
     memcpy( p_newtitle->p_key, p_title_key, KEY_SIZE );
 
     /* Link the new title, either at the beginning or inside the list */
-    if( p_title == NULL )
+    if( p_firsttitle == NULL )
     {
         dvdcss->p_titles = p_newtitle;
         p_newtitle->p_next = NULL;
+    }
+    else if (p_title == NULL)
+    {
+       p_newtitle->p_next = p_firsttitle;
+       p_firsttitle->p_next = NULL;
+       dvdcss->p_titles = p_newtitle;
     }
     else
     {
